首页 > 代码库 > [BestCoder Round #4] hdu 4932 Miaomiao's Geometry (贪心)
[BestCoder Round #4] hdu 4932 Miaomiao's Geometry (贪心)
Miaomiao‘s Geometry
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 363 Accepted Submission(s): 92
Problem Description
There are N point on X-axis . Miaomiao would like to cover them ALL by using segments with same length.
There are 2 limits:
1.A point is convered if there is a segments T , the point is the left end or the right end of T.
2.The length of the intersection of any two segments equals zero.
For example , point 2 is convered by [2 , 4] and not convered by [1 , 3]. [1 , 2] and [2 , 3] are legal segments , [1 , 2] and [3 , 4] are legal segments , but [1 , 3] and [2 , 4] are not (the length of intersection doesn‘t equals zero), [1 , 3] and [3 , 4] are not(not the same length).
Miaomiao wants to maximum the length of segements , please tell her the maximum length of segments.
For your information , the point can‘t coincidently at the same position.
There are 2 limits:
1.A point is convered if there is a segments T , the point is the left end or the right end of T.
2.The length of the intersection of any two segments equals zero.
For example , point 2 is convered by [2 , 4] and not convered by [1 , 3]. [1 , 2] and [2 , 3] are legal segments , [1 , 2] and [3 , 4] are legal segments , but [1 , 3] and [2 , 4] are not (the length of intersection doesn‘t equals zero), [1 , 3] and [3 , 4] are not(not the same length).
Miaomiao wants to maximum the length of segements , please tell her the maximum length of segments.
For your information , the point can‘t coincidently at the same position.
Input
There are several test cases.
There is a number T ( T <= 50 ) on the first line which shows the number of test cases.
For each test cases , there is a number N ( 3 <= N <= 50 ) on the first line.
On the second line , there are N integers Ai (-1e9 <= Ai <= 1e9) shows the position of each point.
There is a number T ( T <= 50 ) on the first line which shows the number of test cases.
For each test cases , there is a number N ( 3 <= N <= 50 ) on the first line.
On the second line , there are N integers Ai (-1e9 <= Ai <= 1e9) shows the position of each point.
Output
For each test cases , output a real number shows the answser. Please output three digit after the decimal point.
Sample Input
3 3 1 2 3 3 1 2 4 4 1 9 100 10
Sample Output
1.000 2.000 8.000HintFor the first sample , a legal answer is [1,2] [2,3] so the length is 1. For the second sample , a legal answer is [-1,1] [2,4] so the answer is 2. For the thired sample , a legal answer is [-7,1] , [1,9] , [10,18] , [100,108] so the answer is 8.
Source
BestCoder Round #4
解题思路:比赛时用二分做的,后来被hack掉了。。
二分结果不对:比如下面这组数据:
4
0 1 4 5
所有可能的线段长度最大可能有两种情况(某两个相邻点之间的距离,某两个相邻点之间的距离的一半)。为什么说是最大,比两个相邻点之间的距离一半小当然没问题。所以我们就把所有相邻的点之间的区间距离以及它的一半保存在数组里面,从小到大排序,逆向遍历,每遍历一个数判断是否符合题意,如果符合,就退出,得到了答案。怎么判断是否符合题意呢?
用到了贪心的思想,能放左边,放左边,不能放左边,放右边。
注意到本题并没有对线段的多少有限制,只要求线段的最大长度,我觉得这个条件对贪心起着关键作用。
代码:
#include <iostream> #include <stdio.h> #include <string.h> #include <queue> #include <stack> #include <algorithm> #include <cmath> #include <iomanip> using namespace std; int num[60]; double inter[120];//区间,里面保留着相邻两个点的区间距离以及区间距离的一半 const int eps=1e-6; int n; bool ok(double l) { double temp=num[1]; for(int i=2;i<=n-1;i++) { if(temp==num[i])//当倒数第二个点正好被覆盖时,不用计算后面tep=num[i]+l if(temp>num[i+1]) 最后那个点是自由的 continue; if(num[i]-l>=temp) temp=num[i]; else { temp=num[i]+l; if(temp>num[i+1]) return false; } } return true; } int main() { int t;cin>>t; while(t--) { scanf("%d",&n); for(int i=1;i<=n;i++) scanf("%d",&num[i]); sort(num+1,num+1+n); int cnt=0; for(int i=1;i<=n;i++) { inter[cnt++]=num[i]-num[i-1]; inter[cnt++]=(num[i]-num[i-1])/2.0; } sort(inter,inter+cnt); double ans=0; for(int i=cnt-1;i>=0;i--) { if(ok(inter[i])) { ans=inter[i]; break; } } cout<<setiosflags(ios::fixed)<<setprecision(3)<<ans<<endl; } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。